Imports System
Imports System.ComponentModel

Imports DevExpress.Xpo
Imports DevExpress.Data.Filtering

Imports DevExpress.ExpressApp
Imports DevExpress.Persistent.Base
Imports DevExpress.Persistent.BaseImpl
Imports DevExpress.Persistent.Validation
Public Enum eOfferAnswerInState
    eReject = 0 'Elutasítás
    eNotSet = -1 'Nincs beállítva
    eAccept = 2 'Elfogadom
End Enum
<DefaultClassOptions(), NavigationItem(False), CreatableItem(False)> _
Public Class OfferAnswerIn 'Bejövő ajánlat fejléc
    Inherits BaseObject

    Private _RegistryHeader As RegistryHeader
    Private _CustomersFrom As CustomersFrom
    Private _Customers As Customers
    Private _Contacts As Contacts
    Private _JobNumberObjects As JobNumberObjects
    Private _DocumentNumber As String

    Private _DateValid As Date
    Private _OfferAnswerInState As eOfferAnswerInState

    Private _ObjectCreated As Date
    Private _UserCreated As User

    Private _OfferAskOut As OfferAskOut

    Public Sub New(ByVal session As Session)
        MyBase.New(session)
        ' This constructor is used when an object is loaded from a persistent storage.
        ' Do not place any code here or place it only when the IsLoading property is false:
        ' if (!IsLoading){
        '   It is now OK to place your initialization code here.
        ' }
        ' or as an alternative, move your initialization code into the AfterConstruction method.
    End Sub
    Public Overrides Sub AfterConstruction()
        MyBase.AfterConstruction()
        ' Place here your initialization code.
    End Sub
    Protected Overrides Sub OnSaving()
        MyBase.OnSaving()
        If Session.IsNewObject(Me) Then
            ObjectCreated = GetSQLTime(Session)
            UserCreated = Session.GetObjectByKey(Of User)(Session.GetKeyValue(SecuritySystem.CurrentUser))
        End If
    End Sub

    Property RegistryHeader As RegistryHeader
        Get
            Return _RegistryHeader
        End Get
        Set(value As RegistryHeader)
            SetPropertyValue("RegistryHeader", _RegistryHeader, value)
        End Set
    End Property
    Property CustomersFrom As CustomersFrom
        Get
            Return _CustomersFrom
        End Get
        Set(value As CustomersFrom)
            SetPropertyValue("CustomersFrom", _CustomersFrom, value)
        End Set
    End Property
    Property Customers As Customers
        Get
            Return _Customers
        End Get
        Set(value As Customers)
            SetPropertyValue("Customers", _Customers, value)
        End Set
    End Property
    Property Contacts As Contacts
        Get
            Return _Contacts
        End Get
        Set(value As Contacts)
            SetPropertyValue("Contacts", _Contacts, value)
        End Set
    End Property

    Property JobNumberObjects As JobNumberObjects
        Get
            Return _JobNumberObjects
        End Get
        Set(value As JobNumberObjects)
            SetPropertyValue("JobNumberObjects", _JobNumberObjects, value)
        End Set
    End Property

    Property DateValid As Date
        Get
            Return _DateValid
        End Get
        Set(value As Date)
            SetPropertyValue("DateValid", _DateValid, value.Date)
        End Set
    End Property
    Property OfferAnswerInState As eOfferAnswerInState
        Get
            Return _OfferAnswerInState
        End Get
        Set(value As eOfferAnswerInState)
            SetPropertyValue("OfferAnswerInState", _OfferAnswerInState, value)
        End Set
    End Property
    <NonCloneable> _
    Property ObjectCreated As Date
        Get
            Return _ObjectCreated
        End Get
        Set(value As Date)
            SetPropertyValue("ObjectCreated", _ObjectCreated, value)
        End Set
    End Property
    <NonCloneable> _
    Property UserCreated As User
        Get
            Return _UserCreated
        End Get
        Set(value As User)
            SetPropertyValue("UserCreated", _UserCreated, value)
        End Set
    End Property

    Property OfferAskOut As OfferAskOut
        Get
            Return _OfferAskOut
        End Get
        Set(value As OfferAskOut)
            SetPropertyValue("OfferAskOut", _OfferAskOut, value)
        End Set
    End Property
    '//XPCollections
    <Association("OfferAnswerIn-OfferAnswerInRows", GetType(OfferAnswerInRows)), VisibleInListView(False), VisibleInLookupListView(False)> _
    ReadOnly Property OfferAnswerInRows As XPCollection(Of OfferAnswerInRows)
        Get
            Return GetCollection(Of OfferAnswerInRows)("OfferAnswerInRows")
        End Get
    End Property
    <Association("OfferAnswerIn-OfferAnswerInDocuments", GetType(OfferAnswerInDocuments)), VisibleInListView(False), VisibleInLookupListView(False)> _
    ReadOnly Property OfferAnswerInDocuments As XPCollection(Of OfferAnswerInDocuments)
        Get
            Return GetCollection(Of OfferAnswerInDocuments)("OfferAnswerInDocuments")
        End Get
    End Property
End Class
